diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-admin/about.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-admin/about.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-admin/about.php	2013-10-30 20:29:21.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-admin/about.php	2014-08-06 22:27:35.000000000 +0400
***************
*** 36,42 ****
  </h2>
  
  <div class="changelog point-releases">
! 	<h3><?php echo _n( 'Maintenance Release', 'Maintenance Releases', 1 ); ?></h3>
  	<p><?php printf( _n( '<strong>Version %1$s</strong> addressed %2$s bug.',
  		'<strong>Version %1$s</strong> addressed %2$s bugs.', 11 ), '3.7.1', number_format_i18n( 11 ) ); ?>
  		<?php printf( __( 'For more information, see <a href="%s">the release notes</a>.' ), 'http://codex.wordpress.org/Version_3.7.1' ); ?>
--- 36,54 ----
  </h2>
  
  <div class="changelog point-releases">
! 	<h3><?php echo _n( 'Maintenance and Security Release', 'Maintenance and Security Releases', 4 ); ?></h3>
! 	<p><?php printf( _n( '<strong>Version %1$s</strong> addressed a security issue.',
!          '<strong>Version %1$s</strong> addressed some security issues.', 5 ), '3.7.4', number_format_i18n( 5 ) ); ?>
! 		<?php printf( __( 'For more information, see <a href="%s">the release notes</a>.' ), 'http://codex.wordpress.org/Version_3.7.4' ); ?>
!  	</p>
! 	<p><?php printf( _n( '<strong>Version %1$s</strong> addressed %2$s bug.',
! 		'<strong>Version %1$s</strong> addressed %2$s bugs.', 2 ), '3.7.3', number_format_i18n( 2 ) ); ?>
! 		<?php printf( __( 'For more information, see <a href="%s">the release notes</a>.' ), 'http://codex.wordpress.org/Version_3.7.3' ); ?>
!  	</p>
! 	<p><?php printf( _n( '<strong>Version %1$s</strong> addressed some security issues and fixed %2$s bug.',
!          '<strong>Version %1$s</strong> addressed some security issues and fixed %2$s bugs.', 9 ), '3.7.2', number_format_i18n( 9 ) ); ?>
! 		<?php printf( __( 'For more information, see <a href="%s">the release notes</a>.' ), 'http://codex.wordpress.org/Version_3.7.2' ); ?>
!  	</p>
  	<p><?php printf( _n( '<strong>Version %1$s</strong> addressed %2$s bug.',
  		'<strong>Version %1$s</strong> addressed %2$s bugs.', 11 ), '3.7.1', number_format_i18n( 11 ) ); ?>
  		<?php printf( __( 'For more information, see <a href="%s">the release notes</a>.' ), 'http://codex.wordpress.org/Version_3.7.1' ); ?>
diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-admin/includes/class-wp-posts-list-table.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-admin/includes/class-wp-posts-list-table.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-admin/includes/class-wp-posts-list-table.php	2013-10-30 20:29:21.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-admin/includes/class-wp-posts-list-table.php	2014-04-07 02:17:10.000000000 +0400
***************
*** 832,838 ****
  	<?php if ( !$bulk ) echo $authors_dropdown;
  	endif; // post_type_supports author
  
! 	if ( !$bulk ) :
  	?>
  
  			<div class="inline-edit-group">
--- 832,838 ----
  	<?php if ( !$bulk ) echo $authors_dropdown;
  	endif; // post_type_supports author
  
! 	if ( !$bulk && $can_publish ) :
  	?>
  
  			<div class="inline-edit-group">
diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-admin/includes/class-wp-upgrader.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-admin/includes/class-wp-upgrader.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-admin/includes/class-wp-upgrader.php	2013-10-30 20:29:21.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-admin/includes/class-wp-upgrader.php	2014-04-03 08:03:09.000000000 +0400
***************
*** 1314,1320 ****
  	}
  
  	function upgrade( $current, $args = array() ) {
! 		global $wp_filesystem, $wp_version;
  
  		$start_time = time();
  
--- 1314,1322 ----
  	}
  
  	function upgrade( $current, $args = array() ) {
! 		global $wp_filesystem;
! 
! 		include ABSPATH . WPINC . '/version.php'; // $wp_version;
  
  		$start_time = time();
  
***************
*** 1333,1340 ****
  			return new WP_Error('up_to_date', $this->strings['up_to_date']);
  
  		$res = $this->fs_connect( array(ABSPATH, WP_CONTENT_DIR) );
! 		if ( is_wp_error($res) )
  			return $res;
  
  		$wp_dir = trailingslashit($wp_filesystem->abspath());
  
--- 1335,1343 ----
  			return new WP_Error('up_to_date', $this->strings['up_to_date']);
  
  		$res = $this->fs_connect( array(ABSPATH, WP_CONTENT_DIR) );
! 		if ( ! $res || is_wp_error( $res ) ) {
  			return $res;
+ 		}
  
  		$wp_dir = trailingslashit($wp_filesystem->abspath());
  
***************
*** 1421,1426 ****
--- 1424,1430 ----
  				'fs_method'        => $wp_filesystem->method,
  				'fs_method_forced' => defined( 'FS_METHOD' ) || has_filter( 'filesystem_method' ),
  				'time_taken'       => time() - $start_time,
+ 				'reported'         => $wp_version,
  				'attempted'        => $current->version,
  			);
  
***************
*** 1868,1885 ****
  		if ( ! $this->should_update( $type, $item, $context ) )
  			return false;
  
  		switch ( $type ) {
  			case 'core':
  				$skin->feedback( __( 'Updating to WordPress %s' ), $item->version );
  				$item_name = sprintf( __( 'WordPress %s' ), $item->version );
  				break;
  			case 'theme':
! 				$theme = wp_get_theme( $item );
  				$item_name = $theme->Get( 'Name' );
  				$skin->feedback( __( 'Updating theme: %s' ), $item_name );
  				break;
  			case 'plugin':
! 				$plugin_data = get_plugin_data( $context . '/' . $item );
  				$item_name = $plugin_data['Name'];
  				$skin->feedback( __( 'Updating plugin: %s' ), $item_name );
  				break;
--- 1872,1892 ----
  		if ( ! $this->should_update( $type, $item, $context ) )
  			return false;
  
+ 		$upgrader_item = $item;
  		switch ( $type ) {
  			case 'core':
  				$skin->feedback( __( 'Updating to WordPress %s' ), $item->version );
  				$item_name = sprintf( __( 'WordPress %s' ), $item->version );
  				break;
  			case 'theme':
! 				$upgrader_item = $item->theme;
! 				$theme = wp_get_theme( $upgrader_item );
  				$item_name = $theme->Get( 'Name' );
  				$skin->feedback( __( 'Updating theme: %s' ), $item_name );
  				break;
  			case 'plugin':
! 				$upgrader_item = $item->plugin;
! 				$plugin_data = get_plugin_data( $context . '/' . $upgrader_item );
  				$item_name = $plugin_data['Name'];
  				$skin->feedback( __( 'Updating plugin: %s' ), $item_name );
  				break;
***************
*** 1891,1902 ****
  		}
  
  		// Boom, This sites about to get a whole new splash of paint!
! 		$upgrade_result = $upgrader->upgrade( $item, array(
  			'clear_update_cache' => false,
  			'pre_check_md5'      => false, /* always use partial builds if possible for core updates */
  			'attempt_rollback'   => true, /* only available for core updates */
  		) );
  
  		// Core doesn't output this, so lets append it so we don't get confused
  		if ( 'core' == $type ) {
  			if ( is_wp_error( $upgrade_result ) ) {
--- 1898,1914 ----
  		}
  
  		// Boom, This sites about to get a whole new splash of paint!
! 		$upgrade_result = $upgrader->upgrade( $upgrader_item, array(
  			'clear_update_cache' => false,
  			'pre_check_md5'      => false, /* always use partial builds if possible for core updates */
  			'attempt_rollback'   => true, /* only available for core updates */
  		) );
  
+ 		// if the filesystem is unavailable, false is returned.
+ 		if ( false === $upgrade_result ) {
+ 			$upgrade_result = new WP_Error( 'fs_unavailable', __( 'Could not access filesystem.' ) );
+ 		}
+ 
  		// Core doesn't output this, so lets append it so we don't get confused
  		if ( 'core' == $type ) {
  			if ( is_wp_error( $upgrade_result ) ) {
***************
*** 1960,1966 ****
  		wp_update_plugins(); // Check for Plugin updates
  		$plugin_updates = get_site_transient( 'update_plugins' );
  		if ( $plugin_updates && !empty( $plugin_updates->response ) ) {
! 			foreach ( array_keys( $plugin_updates->response ) as $plugin ) {
  				$this->update( 'plugin', $plugin );
  			}
  			// Force refresh of plugin update information
--- 1972,1978 ----
  		wp_update_plugins(); // Check for Plugin updates
  		$plugin_updates = get_site_transient( 'update_plugins' );
  		if ( $plugin_updates && !empty( $plugin_updates->response ) ) {
! 			foreach ( $plugin_updates->response as $plugin ) {
  				$this->update( 'plugin', $plugin );
  			}
  			// Force refresh of plugin update information
***************
*** 1971,1978 ****
  		wp_update_themes();  // Check for Theme updates
  		$theme_updates = get_site_transient( 'update_themes' );
  		if ( $theme_updates && !empty( $theme_updates->response ) ) {
! 			foreach ( array_keys( $theme_updates->response ) as $theme ) {
! 				$this->update( 'theme', $theme );
  			}
  			// Force refresh of theme update information
  			wp_clean_themes_cache();
--- 1983,1990 ----
  		wp_update_themes();  // Check for Theme updates
  		$theme_updates = get_site_transient( 'update_themes' );
  		if ( $theme_updates && !empty( $theme_updates->response ) ) {
! 			foreach ( $theme_updates->response as $theme ) {
! 				$this->update( 'theme', (object) $theme );
  			}
  			// Force refresh of theme update information
  			wp_clean_themes_cache();
***************
*** 1987,1994 ****
  
  		// Clean up, and check for any pending translations
  		// (Core_Upgrader checks for core updates)
! 		wp_update_themes();  // Check for Theme updates
! 		wp_update_plugins(); // Check for Plugin updates
  
  		// Finally, Process any new translations
  		$language_updates = wp_get_translation_updates();
--- 1999,2019 ----
  
  		// Clean up, and check for any pending translations
  		// (Core_Upgrader checks for core updates)
! 		$theme_stats = array();
! 		if ( isset( $this->update_results['theme'] ) ) {
! 			foreach ( $this->update_results['theme'] as $upgrade ) {
! 				$theme_stats[ $upgrade->item->theme ] = ( true === $upgrade->result );
! 			}
! 		}
! 		wp_update_themes( $theme_stats );  // Check for Theme updates
! 
! 		$plugin_stats = array();
! 		if ( isset( $this->update_results['plugin'] ) ) {
! 			foreach ( $this->update_results['plugin'] as $upgrade ) {
! 				$plugin_stats[ $upgrade->item->plugin ] = ( true === $upgrade->result );
! 			}
! 		}
! 		wp_update_plugins( $plugin_stats ); // Check for Plugin updates
  
  		// Finally, Process any new translations
  		$language_updates = wp_get_translation_updates();
diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-admin/includes/post.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-admin/includes/post.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-admin/includes/post.php	2013-10-30 20:29:21.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-admin/includes/post.php	2014-04-14 12:13:10.000000000 +0400
***************
*** 100,105 ****
--- 100,109 ----
  		$post_id = false;
  	$previous_status = $post_id ? get_post_field( 'post_status', $post_id ) : false;
  
+ 	if ( isset( $post_data['post_status'] ) && 'private' == $post_data['post_status'] && ! current_user_can( $ptype->cap->publish_posts ) ) {
+ 		$post_data['post_status'] = $previous_status ? $previous_status : 'pending';
+ 	}
+ 
  	$published_statuses = array( 'publish', 'future' );
  
  	// Posts 'submitted for approval' present are submitted to $_POST the same as if they were being published.
***************
*** 111,116 ****
--- 115,124 ----
  	if ( ! isset($post_data['post_status']) )
  		$post_data['post_status'] = $previous_status;
  
+ 	if ( isset( $post_data['post_password'] ) && ! current_user_can( $ptype->cap->publish_posts ) ) {
+ 		unset( $post_data['post_password'] );
+ 	}
+ 
  	if (!isset( $post_data['comment_status'] ))
  		$post_data['comment_status'] = 'closed';
  
***************
*** 170,175 ****
--- 178,191 ----
  	$post_data['post_type'] = $post->post_type;
  	$post_data['post_mime_type'] = $post->post_mime_type;
  
+ 	if ( ! empty( $post_data['post_status'] ) ) {
+ 		$post_data['post_status'] = sanitize_key( $post_data['post_status'] );
+ 
+ 		if ( 'inherit' == $post_data['post_status'] ) {
+ 			unset( $post_data['post_status'] );
+ 		}
+ 	}
+ 
  	$ptype = get_post_type_object($post_data['post_type']);
  	if ( !current_user_can( 'edit_post', $post_ID ) ) {
  		if ( 'page' == $post_data['post_type'] )
***************
*** 187,199 ****
  			_wp_upgrade_revisions_of_post( $post, wp_get_post_revisions( $post_ID ) );
  	}
  
- 	$post_data = _wp_translate_postdata( true, $post_data );
- 	if ( is_wp_error($post_data) )
- 		wp_die( $post_data->get_error_message() );
- 	if ( ( empty( $post_data['action'] ) || 'autosave' != $post_data['action'] ) && 'auto-draft' == $post_data['post_status'] ) {
- 		$post_data['post_status'] = 'draft';
- 	}
- 
  	if ( isset($post_data['visibility']) ) {
  		switch ( $post_data['visibility'] ) {
  			case 'public' :
--- 203,208 ----
***************
*** 210,215 ****
--- 219,232 ----
  		}
  	}
  
+ 	$post_data = _wp_translate_postdata( true, $post_data );
+ 	if ( is_wp_error($post_data) )
+ 		wp_die( $post_data->get_error_message() );
+ 
+ 	if ( ( empty( $post_data['action'] ) || 'autosave' != $post_data['action'] ) && 'auto-draft' == $post_data['post_status'] ) {
+ 		$post_data['post_status'] = 'draft';
+ 	}
+ 
  	// Post Formats
  	if ( isset( $post_data['post_format'] ) )
  		set_post_format( $post_ID, $post_data['post_format'] );
***************
*** 332,337 ****
--- 349,362 ----
  	}
  	unset($post_data['_status']);
  
+ 	if ( ! empty( $post_data['post_status'] ) ) {
+ 		$post_data['post_status'] = sanitize_key( $post_data['post_status'] );
+ 
+ 		if ( 'inherit' == $post_data['post_status'] ) {
+ 			unset( $post_data['post_status'] );
+ 		}
+ 	}
+ 
  	$post_IDs = array_map( 'intval', (array) $post_data['post'] );
  
  	$reset = array(
***************
*** 386,392 ****
--- 411,422 ----
  	}
  
  	$updated = $skipped = $locked = array();
+ 	$shared_post_data = $post_data;
+ 
  	foreach ( $post_IDs as $post_ID ) {
+ 		// Start with fresh post data with each iteration.
+ 		$post_data = $shared_post_data;
+ 
  		$post_type_object = get_post_type_object( get_post_type( $post_ID ) );
  
  		if ( !isset( $post_type_object ) || ( isset($children) && in_array($post_ID, $children) ) || !current_user_can( 'edit_post', $post_ID ) ) {
***************
*** 422,431 ****
--- 452,476 ----
  			unset( $post_data['tax_input']['category'] );
  		}
  
+ 		$post_data['post_type'] = $post->post_type;
  		$post_data['post_mime_type'] = $post->post_mime_type;
  		$post_data['guid'] = $post->guid;
  
+ 		foreach ( array( 'comment_status', 'ping_status', 'post_author' ) as $field ) {
+ 			if ( ! isset( $post_data[ $field ] ) ) {
+ 				$post_data[ $field ] = $post->$field;
+ 			}
+ 		}
+ 
  		$post_data['ID'] = $post_ID;
+ 		$post_data['post_ID'] = $post_ID;
+ 
+ 		$post_data = _wp_translate_postdata( true, $post_data );
+ 		if ( is_wp_error( $post_data ) ) {
+ 			$skipped[] = $post_ID;
+ 			continue;
+ 		}
+ 
  		$updated[] = wp_update_post( $post_data );
  
  		if ( isset( $post_data['sticky'] ) && current_user_can( $ptype->cap->edit_others_posts ) ) {
***************
*** 569,578 ****
  	if ( isset( $_POST['post_ID'] ) )
  		return edit_post();
  
- 	$translated = _wp_translate_postdata( false );
- 	if ( is_wp_error($translated) )
- 		return $translated;
- 
  	if ( isset($_POST['visibility']) ) {
  		switch ( $_POST['visibility'] ) {
  			case 'public' :
--- 614,619 ----
***************
*** 589,594 ****
--- 630,639 ----
  		}
  	}
  
+ 	$translated = _wp_translate_postdata( false );
+ 	if ( is_wp_error($translated) )
+ 		return $translated;
+ 
  	// Create the post.
  	$post_ID = wp_insert_post( $_POST );
  	if ( is_wp_error( $post_ID ) )
diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-admin/includes/update-core.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-admin/includes/update-core.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-admin/includes/update-core.php	2013-10-30 20:29:21.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-admin/includes/update-core.php	2014-04-01 07:36:10.000000000 +0400
***************
*** 697,702 ****
--- 697,705 ----
  
  	// Check to see which files don't really need updating - only available for 3.7 and higher
  	if ( function_exists( 'get_core_checksums' ) ) {
+ 		// Find the local version of the working directory
+ 		$working_dir_local = WP_CONTENT_DIR . '/upgrade/' . basename( $from ) . $distro;
+ 
  		$checksums = get_core_checksums( $wp_version, isset( $wp_local_package ) ? $wp_local_package : 'en_US' );
  		if ( is_array( $checksums ) && isset( $checksums[ $wp_version ] ) )
  			$checksums = $checksums[ $wp_version ]; // Compat code for 3.7-beta2
***************
*** 706,711 ****
--- 709,716 ----
  					continue;
  				if ( ! file_exists( ABSPATH . $file ) )
  					continue;
+ 				if ( ! file_exists( $working_dir_local . $file ) )
+ 					continue;
  				if ( md5_file( ABSPATH . $file ) === $checksum )
  					$skip[] = $file;
  				else
***************
*** 752,760 ****
  	$failed = array();
  	if ( isset( $checksums ) && is_array( $checksums ) ) {
  		foreach ( $checksums as $file => $checksum ) {
! 			if ( 0 === strpos( $file, 'wp-content' ) )
  				continue;
- 
  			if ( file_exists( ABSPATH . $file ) && md5_file( ABSPATH . $file ) == $checksum )
  				$skip[] = $file;
  			else
--- 757,766 ----
  	$failed = array();
  	if ( isset( $checksums ) && is_array( $checksums ) ) {
  		foreach ( $checksums as $file => $checksum ) {
! 			if ( 'wp-content' == substr( $file, 0, 10 ) )
! 				continue;
! 			if ( ! file_exists( $working_dir_local . $file ) )
  				continue;
  			if ( file_exists( ABSPATH . $file ) && md5_file( ABSPATH . $file ) == $checksum )
  				$skip[] = $file;
  			else
***************
*** 765,772 ****
  	// Some files didn't copy properly
  	if ( ! empty( $failed ) ) {
  		$total_size = 0;
- 		// Find the local version of the working directory
- 		$working_dir_local = WP_CONTENT_DIR . '/upgrade/' . basename( $from ) . $distro;
  		foreach ( $failed as $file ) {
  			if ( file_exists( $working_dir_local . $file ) )
  				$total_size += filesize( $working_dir_local . $file );
--- 771,776 ----
***************
*** 882,887 ****
--- 886,896 ----
  	$db_upgrade_url = admin_url('upgrade.php?step=upgrade_db');
  	wp_remote_post($db_upgrade_url, array('timeout' => 60));
  
+ 	// Clear the cache to prevent an update_option() from saving a stale db_version to the cache
+ 	wp_cache_flush();
+ 	// (Not all cache backends listen to 'flush')
+ 	wp_cache_delete( 'alloptions', 'options' );
+ 
  	// Remove working directory
  	$wp_filesystem->delete($from, true);
  
diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-admin/includes/update.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-admin/includes/update.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-admin/includes/update.php	2013-10-30 20:29:21.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-admin/includes/update.php	2014-04-01 07:31:09.000000000 +0400
***************
*** 364,370 ****
  		 * This flag is cleared whenever a successful update occurs using Core_Upgrader.
  		 */
  		$comparison = ! empty( $failed['critical'] ) ? '>=' : '>';
! 		if ( version_compare( $failed['attempted'], $wp_version, '>=' ) )
  			$nag = true;
  	}
  
--- 364,370 ----
  		 * This flag is cleared whenever a successful update occurs using Core_Upgrader.
  		 */
  		$comparison = ! empty( $failed['critical'] ) ? '>=' : '>';
! 		if ( version_compare( $failed['attempted'], $wp_version, $comparison ) )
  			$nag = true;
  	}
  
diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-admin/includes/upgrade.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-admin/includes/upgrade.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-admin/includes/upgrade.php	2013-10-30 20:29:21.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-admin/includes/upgrade.php	2014-04-11 21:29:10.000000000 +0400
***************
*** 405,410 ****
--- 405,416 ----
  	if ( $wp_current_db_version < 25824 )
  		upgrade_370();
  
+ 	if ( $wp_current_db_version < 26148 )
+ 		upgrade_372();
+ 
+ 	if ( $wp_current_db_version < 26149 )
+ 		upgrade_373();
+ 
  	maybe_disable_link_manager();
  
  	maybe_disable_automattic_widgets();
***************
*** 1223,1228 ****
--- 1229,1275 ----
  }
  
  /**
+  * Execute changes made in WordPress 3.7.2.
+  *
+  * @since 3.7.2
+  * @since 3.8.0
+  */
+ function upgrade_372() {
+ 	global $wp_current_db_version;
+ 	if ( $wp_current_db_version < 26148 )
+ 		wp_clear_scheduled_hook( 'wp_maybe_auto_update' );
+ }
+ 
+ /**
+  * Execute changes made in WordPress 3.7.3.
+  *
+  * @since 3.7.3
+  */
+ function upgrade_373() {
+ 	global $wp_current_db_version, $wpdb;
+ 	if ( $wp_current_db_version < 26149 ) {
+ 		// Find all lost Quick Draft auto-drafts and promote them to proper drafts.
+ 		$posts = $wpdb->get_results( "SELECT ID, post_title, post_content FROM $wpdb->posts WHERE post_type = 'post'
+ 			AND post_status = 'auto-draft' AND post_date >= '2014-04-08 00:00:00'" );
+ 
+ 		foreach ( $posts as $post ) {
+ 			// A regular auto-draft should never have content as that would mean it should have been promoted.
+ 			// If an auto-draft has content, it's from Quick Draft and it should be recovered.
+ 			if ( '' === $post->post_content ) {
+ 				// If it does not have content, we must evaluate whether the title should be recovered.
+ 				if ( 'Auto Draft' === $post->post_title || __( 'Auto Draft' ) === $post->post_title ) {
+ 					// This a plain old auto draft. Ignore it.
+ 					continue;
+ 				}
+ 			}
+ 
+ 			$wpdb->update( $wpdb->posts, array( 'post_status' => 'draft' ), array( 'ID' => $post->ID ) );
+ 			clean_post_cache( $post->ID );
+ 		}
+ 	}
+ }
+ 
+ /**
   * Execute network level changes
   *
   * @since 3.0.0
